
//------------設定-----------------------------

var show_arrow='1';
//カゴに入れるボタンを押したときに矢印を出すか(0: 出さない 1: 出す)

var rgb='rgb(128, 128, 128)';
//矢印の色(RGB値)

var arrow_pos='-30';
//矢印の位置(カゴのアイコンから下の長さ)

var move_time='500';
//矢印が動く時間

var fade_time='100';
//矢印が動くときにフェードアウトする時間

//---------------------------------------------


function Check(fo){
var n;
var v;
var number;
var errmsg="";



for(n in fo){
	v=fo[n];
	if(n == "name"){
		name=v;
	}
	if(n == "amount"){
		if(v == "0" || v == ""){
			errmsg+=name+"の個数を選択してください。\n";
		}
	}
	else if(n.indexOf("op") == 0){
		if(v ==""){
			errmsg+=name+"のオプションが選択されていません。\n";
		}
	}
}



if(errmsg ==""){
	if(typeof(st) != "undefined"){
		errmsg+=StockCheck(fo);
	}
}

return errmsg;

}

function StockCheck(fo){
var opflag=false;
var stock;
var msg="";

if(fo['op1'] || fo['op2']){
	opflag=true;
}

var number=fo['number'];
var amount=parseInt(fo['amount']);

if(!opflag){
	var name=fo['name'];
	stock=st[number];
	if(stock == ""){
		stock="0";
	}
	stock=parseInt(stock);
	if(stock == 0){
		msg="申し訳ありません。"+name+"は売り切れです。";
		return msg;
	}
	else if(amount > stock){
		msg="注文数が在庫数より多くなっています。"+name+"の在庫数は"+stock+"です。";
		return msg;
	}
	fo['stock']=stock;
}
else{
	var op=fo['op1'];
	if(fo['op2']){
		op=op+" "+fo['op2'];
	}
	if(st[number]){
		stock=st[number][op];
		stock=parseInt(stock);
		if(stock == 0){
			msg="申し訳ありません。"+number+"の"+op+"は売り切れです。";
			return msg;
		}
		else if(amount > stock){
			msg="注文数が在庫数より多くなっています。"+name+"の"+op+"の在庫数は"+stock+"です。";
			return msg;
		}
	}
	fo['stock']=stock;
}



return msg;
}



function stock(n){
var key;
var msg="";
var flag=0;

if(typeof(st[n]) == "object"){
	var stocknum;
	for(key in st[n]){
		stocknum=st[n][key];
		stocknum=parseInt(stocknum);
		if(stocknum > 0){
			msg+=key+":"+"在庫あり ";
		}
		if(stocknum == 0){
			msg+=key+":"+"売り切れ ";
		}
	}
}
else{
	var stocknum=st[n];
	stocknum=parseInt(stocknum);
	if(stocknum > 0){
		msg="在庫あり";
	}
	if(stocknum == 0){
		msg="売り切れ";
	}

}

document.open();
document.write(msg);
document.close();

}


function Add(fo){
var u=fo.action;
var tag;
var n
var v;
var s;
var flag=false;
var data=new Array();
var r;
var i;
var cnt=0;

for(i=0;i<fo.elements.length;i++){
	n=fo.elements[i].name;
	if(n == "number"){
		cnt++;
		if(cnt > 1){
			break;
		}
	}
}

if(cnt > 1){
	flag=true;
}

cnt=0;

for(i=0;i<fo.elements.length;i++){
	tag=fo.elements[i].tagName;
	n=fo.elements[i].name;
	if(n){
		if(tag == "INPUT"){
			v=fo.elements[i].value;
		}
		else if(tag == "SELECT"){
			v=fo.elements[i].options[fo.elements[i].selectedIndex].value;
		}
		if(flag){
			if(n == "number"){
				cnt++;
			}
			if(cnt){
				s="__"+String(cnt);
				n=n+s;
			}
		}
		data[n]=v;
	}
}


if(!flag){
	r=Check(data);
}
else{
	var data_m=new Array();
	for(n in data){
		if(!n.match("__")){
			continue
		}
		var tmp=n.split("__");
		var name=tmp[0];
		var number=tmp[1];
		if(typeof(data_m[number]) == "undefined"){
			data_m[number]=new Array();
		}
		data_m[number][name]=data[n];
	}

	for(n in data_m){
		if(data_m[n]["amount"] == "0" || data_m[n]["amount"] == ""){
			continue;
		}
		r=Check(data_m[n]);
		if(r){
			break;
		}
	}
}

if(r){
	Alert(r);
	return false;
}


Send("",data,u);

}

function Send(act,data,u){

var xhr=new XMLHttpRequest();

xhr.onreadystatechange = function(){
	switch(xhr.readyState){
		case 0:
			break;
		case 1:
			break;
		case 2:
			break;
		case 3:
			break;
		case 4:
			if(xhr.status == 200 || xhr.status == 304) {
				var txt=xhr.responseText;
				var s=txt.substr(0,3);
				if(act == "postal" || act == "postal_rcpt"){
					if(s == "ok:" || s == "er:"){
						var tmp=txt.split(":");
						if(tmp[0] == "ok"){
							ShowData(act,tmp[2],tmp[3]);
						}
						else{
							var msg_ob_tmp=GetMsgOb(act);
							var msg_ob=msg_ob_tmp[0];
							var ob_tmp=GetOb(act);
							var ob=ob_tmp[0];
							MsgErr(msg_ob,tmp[1]);
							ObErr(ob);
						}
					}
					else{
						var msg_ob_tmp=GetMsgOb(act);
						var msg_ob=msg_ob_tmp[0];
						var ob_tmp=GetOb(act);
						var ob=ob_tmp[0];
						MsgErr(msg_ob,"エラーが発生しました");
						ObErr(ob);
					}
				}
				else{
					var s=txt.substr(0,3);
					if(s == "ok:" || s == "er:"){
						var tmp=txt.split(":");
						if(tmp[0] == "ok"){
							var ob=document.getElementById("amount");
							ob.innerHTML=tmp[1];
							SetCookie(tmp[1]);
							if(parseInt(show_arrow)){
								Arrow();
							}
						}
						else{
							Alert(tmp[1]);
						}
					}
					else{
						Alert(tmp[1]);
					}
				}
			}
			break;
	}
}

xhr.open("POST",u);
xhr.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
xhr.send( EncodeHTMLForm(data));
}

function Alert(e){
	alert(e);
}


function EncodeHTMLForm(data){
var params=[];
for(var name in data){
	var value=data[name];
	var param=encodeURIComponent(name)+'='+encodeURIComponent(value);
	params.push(param);
}
return params.join('&').replace(/%20/g,'+');
}


var endTime=null;
var fadeinTime=null;

function Arrow(){
	if(endTime){
		return;
	}
	
	var cart_ob=document.getElementById("cart_icon");
	var rect = cart_ob.getBoundingClientRect();
	var x = rect.left;
	var y = rect.top;
	x = x + 5;
	y = y + parseInt(arrow_pos) + window.pageYOffset;
	

	var tmp = document.createElement("div");
	tmp.setAttribute("id", "can_box");
	tmp.style.width="22px";
	tmp.style.height="22px";
	tmp.style.position="absolute";
	tmp.style.top=y+"px";
	tmp.style.left=x+"px";
	tmp.style.zIndex="10";

	var canvas = document.createElement("canvas");
	canvas.setAttribute("id", "can");
	canvas.width=22;
	canvas.height=22;
	tmp.appendChild(canvas);
	
	var ctx=canvas.getContext("2d");
	ctx.beginPath();
	ctx.fillStyle = rgb;
	ctx.moveTo(9,2);
	ctx.lineTo(9,17);
	ctx.lineTo(3,11);
	ctx.lineTo(1,13);
	ctx.lineTo(9,21);
	ctx.lineTo(12,21);
	ctx.lineTo(20,13);
	ctx.lineTo(18,11);
	ctx.lineTo(12,17);
	ctx.lineTo(12,2);
	ctx.fill();
	document.body.appendChild(tmp);
	Move();
}


function Move(){
	var m_time=parseInt(move_time);
	var f_time=parseInt(fade_time);
	
	if(!endTime){
		endTime=Date.now() + m_time;
		fadeinTime=Date.now() + f_time;
	}
	
	var ratio = Math.min(1, 1 - (endTime - Date.now()) / m_time);

	var obj = document.getElementById("can_box");
	var top=obj.style.top;
	top=top.replace(/px/, '');
	top=parseInt(top);
	top=top+1;

	obj.style.top = top + "px";
	if(ratio < 1) {
			if(ratio < 0.3){
				obj.style.opacity = Math.min(1, 1 - (fadeinTime - Date.now()) / f_time);
			}
			else if(ratio > 0.7){
				obj.style.opacity = (endTime - Date.now()) / f_time;
			}
			setTimeout(Move, 30);
	}
	else{
		obj.removeChild(obj.firstChild);
		obj.parentNode.removeChild(obj);
		endTime=null;
		fadeinTime=null;
	}

}

function SetCookie(amount){
document.cookie="cart="+amount+"; path=/";
}

function ReadCookie(n){
var c=document.cookie;
var tmp = c.split(';');
var value;
for(var i=0;i<tmp.length;i++){
	var ary=tmp[i].split('=');
	var na=ary[0];
	na=na.replace(/ /g,'');
	if(na == n){
		var v=ary[1];
		v=v.replace(/\+/g,'%20');
		value=decodeURIComponent(v);
		break;
	}
}
return value;

}

function Cart(){
var amount=ReadCookie('cart');
if(typeof(amount) == "undefined"){
	amount="0";
}

var ob=document.getElementById("amount");
ob.innerHTML=amount;

}

function Spinner(act,ob){

var pa=ob.parentElement;
var inp=pa.previousElementSibling;

var cnt=parseInt(inp.value);
if(act == "up"){
	cnt++;
}
else{
	cnt--;
	if(cnt < 0){
		cnt=0;
	}
}

inp.value=cnt;


}

window.onload=Cart;